Index: java/main/src/main/java/com/framsticks/parsers/Loaders.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 84)
@@ -9,5 +9,5 @@
 public class Loaders {
 
-	private static final Logger LOGGER = Logger.getLogger(Loaders.class.getName());
+	private static final Logger log = Logger.getLogger(Loaders.class.getName());
 
 	public static FramsClass loadFramsClass(SourceInterface source) {
@@ -15,9 +15,9 @@
 		loader.setNewSource(source);
 
-        FramsClass result = new FramsClass();
+		FramsClass result = new FramsClass();
 
-        AccessInterface framsClassAccess = new ReflectionAccess(FramsClass.class, FramsClass.getFramsClass());
-        AccessInterface paramBuilderAccess = new ReflectionAccess(ParamBuilder.class, ParamBuilder.getFramsClass());
-        framsClassAccess.select(result);
+		AccessInterface framsClassAccess = new ReflectionAccess(FramsClass.class, FramsClass.getFramsClass());
+		AccessInterface paramBuilderAccess = new ReflectionAccess(ParamBuilder.class, ParamBuilder.getFramsClass());
+		framsClassAccess.select(result);
 		loader.addAccessInterface(framsClassAccess);
 		loader.addAccessInterface(paramBuilderAccess);
@@ -31,9 +31,9 @@
 
 					Object object = loader.returnObject();
-                    if (object instanceof FramsClass) {
-                        continue;
-                    }
-                    if (object instanceof ParamBuilder) {
-                        result.append(((ParamBuilder) object).build());
+					if (object instanceof FramsClass) {
+						continue;
+					}
+					if (object instanceof ParamBuilder) {
+						result.append(((ParamBuilder) object).build());
 					}
 				}
@@ -41,5 +41,5 @@
 			return result;
 		} catch (Exception e) {
-			LOGGER.error("an error occurred while loading class description: " + e + " before " + source.readLine());
+			log.error("an error occurred while loading class description: " + e + " before " + source.readLine());
 			e.printStackTrace();
 		}
Index: java/main/src/main/java/com/framsticks/parsers/Schema.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Schema.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/parsers/Schema.java	(revision 84)
@@ -1,6 +1,4 @@
 package com.framsticks.parsers;
 
-import java.io.File;
-import java.io.FileInputStream;
 import java.io.IOException;
 import java.io.InputStream;
@@ -8,10 +6,7 @@
 import java.util.HashMap;
 import java.util.Map;
-import java.util.Map.Entry;
 
 import com.framsticks.params.*;
-import com.framsticks.params.types.DecimalParam;
-import com.framsticks.params.types.FloatParam;
-import com.framsticks.params.types.StringParam;
+import com.framsticks.util.lang.Numbers;
 import org.apache.log4j.Logger;
 
@@ -224,4 +219,11 @@
 	}
 
+	private static <T extends Number> T extractAttribute(NamedNodeMap attributes, String name, Class<T> type) {
+		String value = getAttribute(attributes, name);
+		if (value == null) {
+			return null;
+		}
+		return Numbers.parse(value, type);
+	}
 	/**
 	 * It analyses the single property within the class
@@ -265,56 +267,22 @@
 		}
 
-		Map<String, String> minMaxDef = new HashMap<String, String>();
-
-		for (String key : new String[] { "MIN", "MAX", "DEF" }) {
-			String value = getAttribute(attributes, key);
-			if (value != null && !value.trim().equals(""))
-				minMaxDef.put(key, value);
-		}
-
 		ParamBuilder builder = new ParamBuilder();
 		builder.setId(id).setName(name).setHelp(description).setGroup(group).setFlags(flags);
 
+		builder.setType(type);
+
 		if ("d".equals(type)) {
-
-			Map<String, Integer> minMaxDefInt = new HashMap<String, Integer>();
-			for (Entry<String, String> entry : minMaxDef.entrySet()) {
-				try {
-					minMaxDefInt.put(entry.getKey(),
-							Integer.parseInt(entry.getValue()));
-				} catch (NumberFormatException e) {
-					logger.warn(entry.getKey() + " attribute in property \""
-							+ id + "\" getId in class \"" + classId
-							+ "\" should be an integer value");
-				}
-			}
-
-			builder.setType(DecimalParam.class);
-			builder.setMin(minMaxDefInt.get("MIN"));
-			builder.setMax(minMaxDefInt.get("MAX"));
-			builder.setDef(minMaxDefInt.get("DEF"));
-
+			builder.setMin(extractAttribute(attributes, "MIN", Integer.class));
+			builder.setMax(extractAttribute(attributes, "MAX", Integer.class));
+			builder.setDef(extractAttribute(attributes, "DEF", Integer.class));
 		} else if ("f".equals(type)) {
-
-			Map<String, Double> minMaxDefDouble = new HashMap<String, Double>();
-			for (Entry<String, String> entry : minMaxDef.entrySet()) {
-				try {
-					minMaxDefDouble.put(entry.getKey(),
-							Double.parseDouble(entry.getValue()));
-				} catch (NumberFormatException e) {
-					logger.warn(entry.getKey() + " attribute in property \""
-							+ id + "\" getId in class \"" + classId
-							+ "\" should be a double value");
-				}
-			}
-			builder.setType(FloatParam.class);
-			builder.setMin(minMaxDefDouble.get("MIN"));
-			builder.setMax(minMaxDefDouble.get("MAX"));
-			builder.setDef(minMaxDefDouble.get("DEF"));
-
-
+			builder.setMin(extractAttribute(attributes, "MIN", Double.class));
+			builder.setMax(extractAttribute(attributes, "MAX", Double.class));
+			builder.setDef(extractAttribute(attributes, "DEF", Double.class));
 		} else if ("s".equals(type)) {
-			builder.setType(StringParam.class);
-			builder.setDef(minMaxDef.get("DEF"));
+			builder.setMin(extractAttribute(attributes, "MIN", Integer.class));
+			builder.setMax(extractAttribute(attributes, "MAX", Integer.class));
+			builder.setDef(extractAttribute(attributes, "DEF", Integer.class));
+			builder.setDef(getAttribute(attributes, "DEF"));
 		} else {
 			builder.setType(type);
Index: java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 84)
@@ -1,5 +1,4 @@
 package com.framsticks.portals;
 
-import com.framsticks.core.Parameters;
 import com.framsticks.observers.Observer;
 import com.framsticks.params.FramsClass;
@@ -13,43 +12,36 @@
 public class Portal extends Observer {
 
-    private final static Logger LOGGER = Logger.getLogger(Portal.class.getName());
+	private final static Logger log = Logger.getLogger(Portal.class.getName());
 
-    public Integer counter = 0;
+	public Integer counter = 0;
 
-    public Portal(Parameters parameters) {
-        super(parameters);
-    }
+	public Portal() {
+	}
 
-    @Override
-    public void run() {
-        super.run();
-        new PeriodicTask(this, 1000) {
+	@Override
+	public void run() {
+		super.run();
+		new PeriodicTask(this, 1000) {
 
-            @Override
-            public void run() {
-                ++counter;
-                LOGGER.debug("counter is now: " + counter);
-                again();
-            }
-        };
-    }
+			@Override
+			public void run() {
+				++counter;
+				log.debug("counter is now: " + counter);
+				again();
+			}
+		};
+	}
 
-    @Override
-    protected void configure() throws Exception {
-        super.configure();
-    }
+	@Override
+	protected PortalEndpoint createEndpoint() {
+		return new PortalEndpoint();
+	}
 
+	public Double getCounterSquared() {
+		return (double)(counter * counter);
+	}
 
-    @Override
-    protected PortalEndpoint createEndpoint() {
-        return new PortalEndpoint();
-    }
-
-    public Double getCounterSquared() {
-        return (double)(counter * counter);
-    }
-
-    public static void constructFramsClass(FramsClass.Constructor constructor) {
-        constructor.method("getCounterSquared").field("counter");
-    }
+	public static void constructFramsClass(FramsClass.Constructor constructor) {
+		constructor.method("getCounterSquared").field("counter");
+	}
 }
Index: java/main/src/main/java/com/framsticks/portals/PortalEndpoint.java
===================================================================
--- java/main/src/main/java/com/framsticks/portals/PortalEndpoint.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/portals/PortalEndpoint.java	(revision 84)
@@ -3,6 +3,6 @@
 import com.framsticks.core.Path;
 import com.framsticks.observers.Endpoint;
-import com.framsticks.util.Dispatching;
-import com.framsticks.util.Future;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.Logging;
 import org.apache.log4j.Logger;
@@ -13,5 +13,5 @@
 public class PortalEndpoint extends Endpoint {
 
-	private final static Logger LOGGER = Logger.getLogger(PortalEndpoint.class.getName());
+	private final static Logger log = Logger.getLogger(PortalEndpoint.class.getName());
 
 	public PortalEndpoint() {
@@ -39,5 +39,5 @@
                     @Override
                     public void result(Path result, Exception e) {
-                        Logging.log(LOGGER, "resolve", path, e);
+                        Logging.log(log, "resolve", path, e);
                     }
                 });
@@ -57,5 +57,5 @@
             @Override
             public void run() {
-                LOGGER.debug("change at " + path);
+                log.debug("change at " + path);
             }
         });
Index: java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 84)
@@ -4,12 +4,12 @@
 import com.framsticks.core.Path;
 import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.Param;
-import com.framsticks.params.types.CompositeParam;
 import com.framsticks.core.Instance;
-import com.framsticks.util.Future;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.StateFunctor;
 import com.framsticks.util.Stopwatch;
 import org.apache.log4j.Logger;
+import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 /**
@@ -18,81 +18,78 @@
 public class RecursiveFetcher {
 
-    private final static Logger LOGGER = Logger.getLogger(RecursiveFetcher.class.getName());
+	private final static Logger log = Logger.getLogger(RecursiveFetcher.class.getName());
 
-    protected final Instance instance;
-    protected final StateFunctor stateFunctor;
-    protected int dispatched;
-    protected final Stopwatch stopwatch = new Stopwatch();
+	protected final Instance instance;
+	protected final StateFunctor stateFunctor;
+	protected int dispatched;
+	protected final Stopwatch stopwatch = new Stopwatch();
 
-    public RecursiveFetcher(Instance instance, final Path path, StateFunctor stateFunctor) {
-        this.instance = instance;
-        this.stateFunctor = stateFunctor;
-        dispatched = 1;
-        process(path);
-    }
+	public RecursiveFetcher(Instance instance, final Path path, StateFunctor stateFunctor) {
+		this.instance = instance;
+		this.stateFunctor = stateFunctor;
+		dispatched = 1;
+		process(path);
+	}
 
-    protected void finished() {
-        assert instance.isActive();
-        LOGGER.info("recursively fetched in " + stopwatch);
-        stateFunctor.call(null);
-    }
+	protected void finished() {
+		assert instance.isActive();
+		log.info("recursively fetched in " + stopwatch);
+		stateFunctor.call(null);
+	}
 
-    protected void process(final Path path) {
-        assert instance.isActive();
-        if (path == null || !path.isResolved()) {
-            LOGGER.warn("path " + path + " is not resolved - skipping");
-        } else {
-            AccessInterface access = instance.bindAccess(path);
-            FramsClass framsClass = access.getFramsClass();
-            assert framsClass != null;
-            for (Param p : access.getParams()) {
-                if (p instanceof CompositeParam) {
-                    CompositeParam childParam = (CompositeParam)p;
-                    Object child = access.get(childParam, Object.class);
-                    final Path childPath = path.appendNode(new Node(childParam, child));
-                    if (childPath.isResolved() && instance.getInfoFromCache(childPath) != null) {
-                        ++dispatched;
-                        instance.invokeLater(new Runnable() {
-                            @Override
-                            public void run() {
-                                fetch(childPath);
-                            }
-                        });
-                        continue;
-                    }
-                    ++dispatched;
-                    instance.resolve(childPath, new Future<Path>() {
-                        @Override
-                        public void result(Path result, Exception e) {
-                            assert instance.isActive();
-                            if (e != null) {
-                                LOGGER.error(e);
-                                return;
-                            }
-                            fetch(result);
-                        }
-                    });
-                }
-            }
-        }
-        --dispatched;
-        if (dispatched == 0) {
-            finished();
-        }
-    }
+	protected void process(final Path path) {
+		assert instance.isActive();
+		if (path == null || !path.isResolved()) {
+			log.warn("path " + path + " is not resolved - skipping");
+		} else {
+			AccessInterface access = instance.bindAccess(path);
+			FramsClass framsClass = access.getFramsClass();
+			assert framsClass != null;
+			for (CompositeParam p : filterInstanceof(access.getParams(), CompositeParam.class)) {
+				Object child = access.get(p, Object.class);
+				final Path childPath = path.appendNode(new Node(p, child));
+				if (childPath.isResolved() && instance.getInfoFromCache(childPath) != null) {
+					++dispatched;
+					instance.invokeLater(new Runnable() {
+						@Override
+						public void run() {
+							fetch(childPath);
+						}
+					});
+					continue;
+				}
+				++dispatched;
+				instance.resolve(childPath, new Future<Path>() {
+					@Override
+					public void result(Path result, Exception e) {
+						assert instance.isActive();
+						if (e != null) {
+							log.error(e);
+							return;
+						}
+						fetch(result);
+					}
+				});
+			}
+		}
+		--dispatched;
+		if (dispatched == 0) {
+			finished();
+		}
+	}
 
-    protected void fetch(final Path path) {
-        instance.fetchValues(path, new StateFunctor() {
-            @Override
-            public void call(Exception e) {
-                if (e != null) {
-                    LOGGER.error("failed to fetch values for " + path + ": " + e);
-                    process(null);
-                    return;
-                }
-                process(path);
-            }
-        });
-    }
+	protected void fetch(final Path path) {
+		instance.fetchValues(path, new StateFunctor() {
+			@Override
+			public void call(Exception e) {
+				if (e != null) {
+					log.error("failed to fetch values for " + path + ": " + e);
+					process(null);
+					return;
+				}
+				process(path);
+			}
+		});
+	}
 
 }
